private import stream;
private import string;

alias toString toStr;

void guardar(Frame window,Stream stream) {
	guardar(window,stream,true);
}

void guardar(Frame window,Stream stream,bit crearMain) {
	Control tmp,_tmp;
	
	with (stream) {
		writeLine('import dig;');
		writeLine('import digfont2;'\n);
		writeLine('class '~window.name~' : Frame {');
		
		declareChildren(window,stream);
		
		writeLine('');
		writeLine(toIndent('this() {',1));
		writeLine(toIndent('super();'\n,2));
		
		window.arreglar();
		writeLine(toIndent('left('~toStr(window.left)~');',2));
		writeLine(toIndent('top('~toStr(window.top)~');',2));
		writeLine(toIndent('width('~toStr(window.width)~');',2));
		writeLine(toIndent('height('~toStr(window.height)~');',2));
		if (window.caption.length>0)
			writeLine(toIndent('caption("'~window.caption~'");',2));
		if (!window.captionbar)
			writeLine(toIndent('captionbar( false );',2));
		if (!window.maxbox)
			writeLine(toIndent('maximizable( false );',2));
		if (!window.minbox)
			writeLine(toIndent('minimizable( false );',2));
		if (!window.resize)
			writeLine(toIndent('resizable( false );',2));
		if (!window.controlbox)
			writeLine(toIndent('sysmenu( false );',2));
		
		withChildren(window,stream);
		
		window.guardarFont(stream,2);

		writeLine(toIndent('}',1));
		writeLine('}');
		
		if (crearMain)
			writeLine(\n'void main() {'\n"\t(new "~window.name~'()).showModal();'\n'}');
	}
}

private class Control {
	char[]    name;
	Control[] children;
	private
	Control   _parent;
	uint      left;
	uint      top;
	uint      width;
	uint      height;
	bit       hscroll;
	bit       vscroll;
	
	char[]    fontName='MS Sans Serif';
	uint      fontSize=8;
	bit       fontBold;
	bit       fontItalic;
	bit       fontUnderline;
	bit       fontStrikeout;
	bit       fontSet=false;	

	void guardarFont(Stream stream,uint indent) {
		
		void guardar(Stream stream,uint indent,bit conNombre) {
			
			char[] bit2Str(bit b) {
				if (b) return 'true'; else return 'false';
			}
			
			with (stream) {
				writeLine('');
				writeLine(toIndent('with (new DigFont(font())) {',indent));
				writeLine(toIndent('name("'~fontName~'");',indent+1));
				writeLine(toIndent('size(this,'~toStr(fontSize)~');',indent+1));
				writeLine(toIndent('bold('~bit2Str(fontBold)~');',indent+1));
				writeLine(toIndent('italic('~bit2Str(fontItalic)~');',indent+1));
				writeLine(toIndent('underline('~bit2Str(fontUnderline)~');',indent+1));
				writeLine(toIndent('strikeout('~bit2Str(fontStrikeout)~');',indent+1));
				if (conNombre)
					writeLine(toIndent('assignTo('~name~',true);',indent+1));
				else
					writeLine(toIndent('assignTo(this,true);',indent+1));
				writeLine(toIndent('}',indent));
			}
		}
			
		if (_parent===null)
			guardar(stream,indent,false);
		else
			if (fontSet && !cmpFont(this,this._parent))
				guardar(stream,indent,true);
		
		for (int i=0;i<children.length;i++)
			children[i].guardarFont(stream,indent);
	}
	
	private static bit cmpFont(Control c1,Control c2) {
		return icmp(c1.fontName,c2.fontName)==0
			&& c1.fontSize==c2.fontSize
			&& c1.fontBold==c2.fontBold
			&& c1.fontItalic==c2.fontItalic
			&& c1.fontUnderline==c2.fontUnderline;
	}
	
	void parent(Control p) {
		_parent=p;
		p.children ~= this;
	}
}

private void withChildren(Control c,Stream stream) {
	Control tmp;
	for (int i=0;i<c.children.length;i++) {
		stream.writeLine('');
		tmp=c.children[i];
		if (cast(Button)tmp)
			guardar(cast(Button)tmp,stream,2);
		else if (cast(GroupBox)tmp)
			guardar(cast(GroupBox)tmp,stream,2);
		else if (cast(ListBox)tmp)
			guardar(cast(ListBox)tmp,stream,2);
		else if (cast(ComboBox)tmp)
			guardar(cast(ComboBox)tmp,stream,2);
		else if (cast(EditText)tmp)
			guardar(cast(EditText)tmp,stream,2);
		else if (cast(CheckBox)tmp)
			guardar(cast(CheckBox)tmp,stream,2);
		else if (cast(Label)tmp)
			guardar(cast(Label)tmp,stream,2);
		else if (cast(RadioButton)tmp)
			guardar(cast(RadioButton)tmp,stream,2);
		withChildren(tmp,stream);
	}
}

private void declareChildren(Control c,Stream stream) {
	Control tmp;
	for (int i=0;i<c.children.length;i++) {
		tmp=c.children[i];
		if (cast(Button)tmp)
			stream.writeLine(toIndent('Button '~tmp.name~';',1));
		else if (cast(GroupBox)tmp)
			stream.writeLine(toIndent('GroupBox '~tmp.name~';',1));
		else if (cast(ListBox)tmp)
			stream.writeLine(toIndent('ListBox '~tmp.name~';',1));
		else if (cast(ComboBox)tmp)
			stream.writeLine(toIndent('ComboBox '~tmp.name~';',1));
		else if (cast(EditText)tmp)
			stream.writeLine(toIndent('EditText '~tmp.name~';',1));
		else if (cast(CheckBox)tmp)
			stream.writeLine(toIndent('Checkbox '~tmp.name~';',1));
		else if (cast(Label)tmp)
			stream.writeLine(toIndent('Label '~tmp.name~';',1));
		else if (cast(RadioButton)tmp)
			stream.writeLine(toIndent('RadioButton '~tmp.name~';',1));
		declareChildren(tmp,stream);
	}
}

private void guardar(Button x,Stream stream,ubyte indent) {
	with (stream) {
		char[] tmp = 'with ( '~x.name~'=new Button(';
		if (cast(Frame)x._parent)
			tmp ~= 'this) ) {';
		else
			tmp ~= x._parent.name~') ) {';
		writeLine(toIndent(tmp,indent));
		writeLine(toIndent('grid(0,0);',indent+1));
		writeLine(toIndent('left('~toStr(x.left)~');',indent+1));
		writeLine(toIndent('top('~toStr(x.top)~');',indent+1));
		writeLine(toIndent('width('~toStr(x.width)~');',indent+1));
		writeLine(toIndent('height('~toStr(x.height)~');',indent+1));
		if (x.caption.length>0)
			writeLine(toIndent('caption("'~x.caption~'");',indent+1));
		if (x.bordered)
			writeLine(toIndent('bordered( true );',indent+1));
		writeLine(toIndent('}',indent));
	}
}

private void guardar(GroupBox x,Stream stream,ubyte indent) {
	with (stream) {
		char[] tmp = 'with ( '~x.name~'=new GroupBox(';
		if (cast(Frame)x._parent)
			tmp ~= 'this) ) {';
		else
			tmp ~= x._parent.name~') ) {';
		writeLine(toIndent(tmp,indent));
		writeLine(toIndent('grid(0,0);',indent+1));
		writeLine(toIndent('left('~toStr(x.left)~');',indent+1));
		writeLine(toIndent('top('~toStr(x.top)~');',indent+1));
		writeLine(toIndent('width('~toStr(x.width)~');',indent+1));
		writeLine(toIndent('height('~toStr(x.height)~');',indent+1));
		writeLine(toIndent('caption("'~x.caption~'");',indent+1));
		writeLine(toIndent('}',indent));
	}
}

private void guardar(ListBox x,Stream stream,ubyte indent) {
	with (stream) {
		char[] tmp = 'with ( '~x.name~'=new ListBox(';
		if (cast(Frame)x._parent)
			tmp ~= 'this) ) {';
		else
			tmp ~= x._parent.name~') ) {';
		writeLine(toIndent(tmp,indent));
		writeLine(toIndent('grid(0,0);',indent+1));
		writeLine(toIndent('left('~toStr(x.left)~');',indent+1));
		writeLine(toIndent('top('~toStr(x.top)~');',indent+1));
		writeLine(toIndent('width('~toStr(x.width)~');',indent+1));
		writeLine(toIndent('height('~toStr(x.height)~');',indent+1));
		writeLine(toIndent('addColumn("",'~toStr(x.width)~');',indent+1));
		writeLine(toIndent('}',indent));
	}
}

private void guardar(ComboBox x,Stream stream,ubyte indent) {
	with (stream) {
		char[] tmp = 'with ( '~x.name~'=new ComboBox(';
		if (cast(Frame)x._parent)
			tmp ~= 'this) ) {';
		else
			tmp ~= x._parent.name~') ) {';
		writeLine(toIndent(tmp,indent));
		writeLine(toIndent('grid(0,0);',indent+1));
		writeLine(toIndent('left('~toStr(x.left)~');',indent+1));
		writeLine(toIndent('top('~toStr(x.top)~');',indent+1));
		writeLine(toIndent('width('~toStr(x.width)~');',indent+1));
		writeLine(toIndent('height('~toStr(x.height)~');',indent+1));
		if (x.list.length>0) {
			if (x.text.length>0)
				writeLine(toIndent('current("'~x.text~'");',indent+1));
			for (int i=0;i<x.list.length;i++)
				writeLine(toIndent('add("'~x.list[0]~'");',indent+1));
		}
		writeLine(toIndent('}',indent));
	}
}

private void guardar(EditText x,Stream stream,ubyte indent) {
	with (stream) {
		char[] tmp = 'with ( '~x.name~'=new EditText(';
		if (cast(Frame)x._parent)
			tmp ~= 'this) ) {';
		else
			tmp ~= x._parent.name~') ) {';
		writeLine(toIndent(tmp,indent));
		writeLine(toIndent('grid(0,0);',indent+1));
		writeLine(toIndent('left('~toStr(x.left)~');',indent+1));
		writeLine(toIndent('top('~toStr(x.top)~');',indent+1));
		writeLine(toIndent('width('~toStr(x.width)~');',indent+1));
		writeLine(toIndent('height('~toStr(x.height)~');',indent+1));
		if (x.text.length>0)
			writeLine(toIndent('text("'~x.text~'");',indent+1));
		if (!x.border)
			writeLine(toIndent('bordered( false );',indent+1));
		if (x.hscroll)
			writeLine(toIndent('hscroll( true );',indent+1));
		if (x.vscroll)
			writeLine(toIndent('vscroll( true );',indent+1));
		writeLine(toIndent('}',indent));
	}
}

private void guardar(CheckBox x,Stream stream,ubyte indent) {
	with (stream) {
		char[] tmp = 'with ( '~x.name~'=new Checkbox(';
		if (cast(Frame)x._parent)
			tmp ~= 'this) ) {';
		else
			tmp ~= x._parent.name~') ) {';
		writeLine(toIndent(tmp,indent));
		writeLine(toIndent('grid(0,0);',indent+1));
		writeLine(toIndent('left('~toStr(x.left)~');',indent+1));
		writeLine(toIndent('top('~toStr(x.top)~');',indent+1));
		writeLine(toIndent('width('~toStr(x.width)~');',indent+1));
		writeLine(toIndent('height('~toStr(x.height)~');',indent+1));
		if (x.caption.length>0)
			writeLine(toIndent('caption("'~x.caption~'");',indent+1));
		if (x.checked)
			writeLine(toIndent('checked( true );',indent+1));
		writeLine(toIndent('}',indent));
	}
}

private void guardar(Label x,Stream stream,ubyte indent) {
	with (stream) {
		char[] tmp = 'with ( '~x.name~'=new Label(';
		if (cast(Frame)x._parent)
			tmp ~= 'this) ) {';
		else
			tmp ~= x._parent.name~') ) {';
		writeLine(toIndent(tmp,indent));
		writeLine(toIndent('grid(0,0);',indent+1));
		writeLine(toIndent('left('~toStr(x.left)~');',indent+1));
		writeLine(toIndent('top('~toStr(x.top)~');',indent+1));
		writeLine(toIndent('width('~toStr(x.width)~');',indent+1));
		writeLine(toIndent('height('~toStr(x.height)~');',indent+1));
		if (x.caption.length>0)
			writeLine(toIndent('caption("'~x.caption~'");',indent+1));
		if (!x.alignLeft)
			writeLine(toIndent('alignLeft( false );',indent+1));
		else if (x.alignRight)
			writeLine(toIndent('alignRight( true );',indent+1));
		writeLine(toIndent('}',indent));
	}
}

private void guardar(RadioButton x,Stream stream,ubyte indent) {
	with (stream) {
		char[] tmp = 'with ( '~x.name~'=new RadioButton(';
		if (cast(Frame)x._parent)
			tmp ~= 'this) ) {';
		else
			tmp ~= x._parent.name~') ) {';
		writeLine(toIndent(tmp,indent));
		writeLine(toIndent('grid(0,0);',indent+1));
		writeLine(toIndent('left('~toStr(x.left)~');',indent+1));
		writeLine(toIndent('top('~toStr(x.top)~');',indent+1));
		writeLine(toIndent('width('~toStr(x.width)~');',indent+1));
		writeLine(toIndent('height('~toStr(x.height)~');',indent+1));
		if (x.caption.length>0)
			writeLine(toIndent('caption("'~x.caption~'");',indent+1));
		if (x.enabled)
			writeLine(toIndent('enabled( true );',indent+1));
		else
			writeLine(toIndent('enabled( false );',indent+1));
		writeLine(toIndent('}',indent));
	}
}

private char[] toIndent(char[] txt,ubyte indent) {
	char[] res=txt.dup;
	for (ubyte i=0;i<indent;i++)
		res = "\t"~res;
	return res;
}

class Button:Control {
	char[]    caption;
	bit       bordered;
}

private class Canvas:Control {
}

class GroupBox:Canvas {
	char[]    caption;
}

class ListBox:Canvas {
}

class CheckBox:Control {
	char[]    caption;
	bit       checked;
}

class ComboBox:Control {
	char[]    text;
	char[][]  list;
}

class EditText:Control {
	char[]    text;
	bit       border=true;
}

class Frame:Control {
	char[]    caption;
	bit       captionbar=true;
	bit       maxbox=true;
	bit       minbox=true;
	bit       resize=true;
	bit       controlbox=true;
	ubyte     scalemode=1;
	int       s_width,s_height;
	
	void arreglar() {
		arreglar(this,scalemode);
	}
	
	private void arreglar(Control c,ubyte sm) {
		with (c)
			switch (sm) {
				case 2: //point
					width *= (4./3.);
					height *= (4./3.);
					left *= (4./3.);
					top *= (4./3.);
					break;
				case 3: //pixel
					break;
				case 4: //chars
					width *= 8;
					height *= 16;
					left *= 8;
					top *= 16;
					break;
				case 5: //inches
					width *= 96;
					height *= 96;
					left *= 96;
					top *= 96;
					break;
				case 6: //mm
					width *= (96*25.4);
					height *= (96*25.4);
					left *= (96*25.4);
					top *= (96*25.4);
					break;
				case 7: //cm
					width *= (96*2.54);
					height *= (96*2.54);
					left *= (96*2.54);
					top *= (96*2.54);
					break;
				default: //1:twip (por defecto en vb)
					width /= 15;
					height /=15;
					left /= 15;
					top /=15;
			}		
		for (int i=0;i<c.children.length;i++)
			arreglar(c.children[i],scalemode);
	}
}

class Label:Control {
	char[]    caption;
	bit       alignLeft=true;
	bit       alignRight;
}

private class Pane:Control {
}

class RadioButton:Control {
	char[]    caption;
	bit       enabled;
}

private class Spinner:Control {
}

private class Splitter:Control {
}

private class RadioGroup {
}

private class Menu {
}

private class MenuBar:Menu {
}
	
/*
-RadioGroup
+Menu
|-MenuBar
+Control
|-Button
|+Canvas
||-GroupBox
||-ListBox
|-Checkbox
|-ComboBox
|-EditText
|-Frame
|-Label
|-Pane
|-RadioButton
|-Spinner
|-Splitter

CONTROL
Control[] children;
Control   parent;
int       left           -> left;
int       top            -> top;
int       width          -> width;
int       height         -> height;
bit       hscroll        -> hscroll;
bit       vscroll        -> vscroll;
char[]    fontName;
uint      fontSize;
bit       fontBold;
bit       fontItalic;
bit       fontUnderline;
bit       fontStrikeout;
bit       fontSet;

BUTTON
char[]    caption        -> caption;
bit       bordered       -> bordered;

CANVAS

GROUPBOX
char[]    caption        -> caption;

LISTBOX

CHECKBOX
char[]    caption        -> caption;
bit       checked        -> checked;

COMBOBOX
char[]    text           -> current;
char[][]  list           -> add;

EDITTEXT
char[]    text           -> text;
bit       border         -> bordered;

FRAME
char[]    caption        -> caption;
bit       captionbar     -> captionbar;
bit       maxbox         -> maximizable;
bit       minbox         -> minimizable;
bit       resize         -> resizable;
bit       controlbox     -> sysmenu;

LABEL
char[]    caption        -> caption;
bit       alignLeft      -> alignLeft;
bit       alignRight     -> alignRight;

RADIOBUTTON
char[]    caption        -> caption;
bit       enabled        -> enabled;

*/